## Sid Meier's Civilization 4
## Copyright Firaxis Games 2005
## 
## CvAoDEventManager
## This class is passed an argsList from CvAppInterface.onEvent
## The argsList can contain anything from mouse location to key info
## The EVENTLIST that are being notified can be found 


from CvPythonExtensions import *
import CvUtil
import CvScreensInterface
import CvDebugTools
import CvWBPopups
import PyHelpers
import Popup as PyPopup
import CvCameraControls
import CvTopCivs
import CvEventManager
import CvIntroMovieScreen
import sys
	
gc = CyGlobalContext()
localText = CyTranslator()
PyPlayer = PyHelpers.PyPlayer
PyInfo = PyHelpers.PyInfo
DefaultUnitAI = UnitAITypes.NO_UNITAI

# The main bits
# The quotes from Columbus were found in The Conquest of America by Todorov.  Then I copied and pasted whole #quote from where I could find them in google books.  Otherwise the page is noted from Conquest of America
###################################################
class CvAoDEventManager(CvEventManager.CvEventManager):
	def __init__(self):
		# initialize base class
		self.parent = CvEventManager.CvEventManager
		self.parent.__init__(self)
		

	def onGameStart(self, argsList):
		# my variables (Todd)
		global strColumbusVisited4220
		global strColumbusVisited4516
		global strColumbusVisited5616
		global strColumbusVisited6317
		global strColumbusVisited3725
		global strColumbusVisited2827
		global strColumbusVisited3331


		global strGameYear
		strColumbusVisited4220 = 'false'
		strColumbusVisited4516 = 'false'
		strColumbusVisited5616 = 'false'
		strColumbusVisited6317 = 'false'
		strColumbusVisited3725 = 'false'
		strColumbusVisited2827 = 'false'
		strColumbusVisited3331 = 'false'


                # display mod's intro movie
                introMovie = CvIntroMovieScreen.CvIntroMovieScreen()
        	introMovie.interfaceScreen()
		
        	
		# display DoM message
		for iPlayer in range(gc.getMAX_PLAYERS()):
			player = gc.getPlayer(iPlayer)
			if (player.isAlive() and player.isHuman()):
				popupInfo = CyPopupInfo()
				popupInfo.setButtonPopupType(ButtonPopupTypes.BUTTONPOPUP_PYTHON_SCREEN)
				popupInfo.setText(u"showDawnOfMan")
				popupInfo.addPopup(iPlayer)

	# My function (Todd) Gives a popup message when UNITCLASS_COLUMBUS hits X Y coordinates, use MapView program to find coordinates
	def onUnitMove(self, argsList):
		global strColumbusVisited4220
		global strColumbusVisited4516
		global strColumbusVisited5616
		global strColumbusVisited6317
		global strColumbusVisited3725
		global strColumbusVisited2827
		global strColumbusVisited3331

		
		pPlot4220 = CyMap().plot(42,20)
		pPlot4516 = CyMap().plot(45,16)
		pPlot5616 = CyMap().plot(56,16)
		pPlot6317 = CyMap().plot(63,17)
		pPlot3725 = CyMap().plot(37,25)
		pPlot2827 = CyMap().plot(28,27)
		pPlot3331 = CyMap().plot(33,31)

		iActivePlayer = CyGame().getActivePlayer()
		pUnit = argsList[0]

		
		if strColumbusVisited4220 != 'true':
			
			for i in range(pPlot4220.getNumUnits()):				
				pUnit = pPlot4220.getUnit(i)

				iColumbus = gc.getInfoTypeForString('UNITCLASS_COLUMBUS')
		
				if pUnit.getUnitClassType() == iColumbus and iActivePlayer == 2:
					popup = PyPopup.PyPopup()
					popup.setHeaderString("Journey of Christopher Columbus")
					popup.setBodyString("The Admiral called upon the two Captains, and the rest of the crew who landed, as also to Rodrigo de Escovedo notary of the fleet, and Rodrigo Sanchez, of Segovia, to bear witness that he before all others took possession (as in fact he did) of that island for the King and Queen his sovereigns, making the requisite declarations, which are more at large set down here in writing. Numbers of the people of the island straightway collected together. Here follow the precise words of the Admiral: 'As I saw that they were very friendly to us, and perceived that they could be much more easily converted to our holy faith by gentle means than by force, I presented them with some red caps, and strings of beads to wear upon the neck, and many other trifles of small value, wherewith they were much delighted, and became wonderfully attached to us. Afterwards they came swimming to the boats, bringing parrots, balls of cotton thread, javelins, and many other things which they exchanged for articles we gave them, such as glass beads, and hawk's bells; which trade was carried on with the utmost good will. But they seemed on the whole to me, to be a very poor people. They all go completely naked, even the women, though I saw but one girl. All whom I saw were young, not above thirty years of age, well made, with fine shapes and faces; their hair short, and coarse like that of a horse's tail, combed toward the forehead, except a small portion which they suffer to hang down behind, and never cut. Some paint themselves with black, which makes them appear like those of the Canaries, neither black nor white; others with white, others with red, and others with such colors as they can find. Some paint the face, and some the whole body; others only the eyes, and others the nose. Weapons they have none, nor are acquainted with them, for I showed them swords which they grasped by the blades, and cut themselves through ignorance. They have no iron, their javelins being without it, and nothing more than sticks, though some have fish-bones or other things at the ends. They are all of a good size and stature, and handsomely formed. I saw some with scars of wounds upon their bodies, and demanded by signs the of them; they answered me in the same way, that there came people from the other islands in the neighborhood who endeavored to make prisoners of them, and they defended themselves. I thought then, and still believe, that these were from the continent. It appears to me, that the people are ingenious, and would be good servants and I am of opinion that they would very readily become Christians, as they appear to have no religion. They very quickly learn such words as are spoken to them. If it please our Lord, I intend at my return to carry home six of them to your Highnesses, that they may learn our language. I saw no beasts in the island, nor any sort of animals except parrots.' Masterworks of Travel and Exploration, 86")
					popup.addButton("Ok")
					popup.launch(False, PopupStates.POPUPSTATE_IMMEDIATE)
					strColumbusVisited4220 = 'true'

		if strColumbusVisited4516 != 'true':

			for i in range(pPlot4516.getNumUnits()):				
				pUnit = pPlot4516.getUnit(i)

				iColumbus = gc.getInfoTypeForString('UNITCLASS_COLUMBUS')
		
				if pUnit.getUnitClassType() == iColumbus and iActivePlayer == 2:
					popup = PyPopup.PyPopup()
					popup.setHeaderString("Journal, Christopher Columbus")
					popup.setBodyString("They seem to imply that there is mainland behind Espanola, and they call it Caritaba, and say it is of vast extent. They have reason in saying that the inhabitants are a clever race, for all the people of these islands are in great fear of those of Caniba. So the Admiral repeats, what he has said before, that Caniba is nothing else but the Gran Can, who ought now to be very near. He sends ships to capture the islanders ; and as they do not return, their countrymen believe that they have been eaten. Each day we understand better what the Indians say, and they us, so that very often we are intelligible to each other. The Admiral sent people on shore, who found a great deal of mastick, but did not gather it. He says that the rains make it, and that in Chios they collect it in March. In these lands, being warmer, they might take it in January. They caught many fish like those of Castilledace,1 salmon, hake,2 dory,3 gilt heads,4 skates,6 corbinas? shrimps,7 and they saw sardines. They found many aloes (Journal of Christopher Columbus, 106)")
					popup.addButton("Ok")
					popup.launch(False, PopupStates.POPUPSTATE_IMMEDIATE)
					strColumbusVisited4516 = 'true'

		if strColumbusVisited5616 != 'true':

			for i in range(pPlot5616.getNumUnits()):				
				pUnit = pPlot5616.getUnit(i)

				iColumbus = gc.getInfoTypeForString('UNITCLASS_COLUMBUS')
		
				if pUnit.getUnitClassType() == iColumbus and iActivePlayer == 2:
					popup = PyPopup.PyPopup()
					popup.setHeaderString("Journey of Christopher Columbus")
					popup.setBodyString("Moreover he did not understand them any better than they understood him, and they were greatly afraid of the people on this new island.  Therefore, in order to make converse with its people, he would have had to tarry there for several days.  But he did not do so, in order to see further lands and from the doubt that the weather would hold.  The Conquest of America, 33")
					popup.addButton("Ok")
					popup.launch(False, PopupStates.POPUPSTATE_IMMEDIATE)
					strColumbusVisited5616 = 'true'

		if strColumbusVisited6317 != 'true':

			for i in range(pPlot6317.getNumUnits()):				
				pUnit = pPlot6317.getUnit(i)

				iColumbus = gc.getInfoTypeForString('UNITCLASS_COLUMBUS')
		
				if pUnit.getUnitClassType() == iColumbus and iActivePlayer == 2:
					popup = PyPopup.PyPopup()
					popup.setHeaderString("Journey of Christopher Columbus")
					popup.setBodyString("They are without covetousness of another mans's goods.  They are to such a degree lacking in articfice and so generous with what they possess, that no man would believe it unless he had seen such a thing.  And let it not be said, the Admiral said, that they give liberally only because what they gave was of little worth, for those who game pieces of gold and those who gave a water calabash acted in the same way and just as liberally.  And it is an easy thing to know, when a thing is given, that it is given with a free heart. The Conquest of America, 39")
					popup.addButton("Ok")
					popup.launch(False, PopupStates.POPUPSTATE_IMMEDIATE)
					strColumbusVisited6317 = 'true'


		if strColumbusVisited2827 != 'true':

			for i in range(pPlot2827.getNumUnits()):				
				pUnit = pPlot2827.getUnit(i)

				iColumbus = gc.getInfoTypeForString('UNITCLASS_COLUMBUS')
		
				if pUnit.getUnitClassType() == iColumbus and iActivePlayer == 2:
					popup = PyPopup.PyPopup()
					popup.setHeaderString("Journal, Christopher Columbus 28, 27")
					popup.setBodyString("They are no people so wicked as the cowardly who never risk their life face to face, and shall know that if the Indians find one or two men separated from the rest, it will not be surprising if they should kill them.  The Conquest of America, 40")
					popup.addButton("Ok")
					popup.launch(False, PopupStates.POPUPSTATE_IMMEDIATE)
					strColumbusVisited2827 = 'true'

		if strColumbusVisited3725 != 'true':

			for i in range(pPlot3725.getNumUnits()):				
				pUnit = pPlot3725.getUnit(i)

				iColumbus = gc.getInfoTypeForString('UNITCLASS_COLUMBUS')
		
				if pUnit.getUnitClassType() == iColumbus and iActivePlayer == 2:
					popup = PyPopup.PyPopup()
					popup.setHeaderString("Journal, Christopher Columbus")
					popup.setBodyString("Your Highness may have great joy of them, for soon you will have made them into Christians and will have instructed them in the good manners of your kingdoms.  And I say that Your Highness must not permit any foreigner to conduct business with this country or to set foot in iti if hi is not a Catholic Christian, for the end and the beginning of this enterprise was the propogation and the glory of the Christian religion, and not to admit into these regions any man who may not be a good Christian. ")
					popup.addButton("Ok")
					popup.launch(False, PopupStates.POPUPSTATE_IMMEDIATE)
					strColumbusVisited3725 = 'true'

		if strColumbusVisited3331 != 'true':

			for i in range(pPlot3331.getNumUnits()):				
				pUnit = pPlot3331.getUnit(i)

				iColumbus = gc.getInfoTypeForString('UNITCLASS_COLUMBUS')
		
				if pUnit.getUnitClassType() == iColumbus and iActivePlayer == 2:
					popup = PyPopup.PyPopup()
					popup.setHeaderString("Journey of Christopher Columbus")
					popup.setBodyString("Sailor's account - While I was in the boat, I captured a very beautiful Carib woman, whom the aforesaid Lord Admiral gave to me, and with whom, having brought her into my cabin, and she being naked as is their custom, I conceived the desire to take my pleasure.  I wanted to put my desire to execution, but she was unwilling for me to do so, and treated me with her nails in such wise that I would have preferred never to have begun.  But seeing this (in order to tell you the whole even to the end), I took a rope-end and thrashed her well, following which she produced such screaming and wailing as would cause you not to believe your ears.  Finally, we reached an agreement such that, I can tell you, she seemed to have been raised by a veritable school of harlots. Conquest of America, 48-49")
					popup.addButton("Ok")
					popup.launch(False, PopupStates.POPUPSTATE_IMMEDIATE)
					strColumbusVisited3331 = 'true'



		
	def onBeginGameTurn(self, argsList):
		iGameTurn = argsList[0]
		intCortesCreatedTurn = 1
		intCurrentTurn = CyGame().getGameTurn()

		
		if intCortesCreatedTurn == intCurrentTurn and iActivePlayer == 2:
		
		
			pPlayer = gc.getPlayer(2)
		
			zNewUnit = pPlayer.initUnit(gc.getInfoTypeForString('UNIT_CORTES'), 42, 20, UnitAITypes.NO_UNITAI)

			popup = PyPopup.PyPopup()
			popup.setHeaderString("Cortes")
			popup.setBodyString("Cortes leaves Cuba")
			popup.addButton("Ok")
			popup.launch(False, PopupStates.POPUPSTATE_IMMEDIATE)

		
		# Age of Discovery events
		self.turnChecker(iGameTurn)

# AoD Events
###################################################

	def turnChecker(self, iTurn):
		
                # Civ inits
                self.iEnglandID = 0
                self.iFranceID = 1
                self.iSpainID = 2
                self.iPortugalID = 5
                self.iHollandID = 7
                self.iScotlandID = 10
                self.iSaxonyID = 3
                self.iGenoaID = 4
                self.iArabID = 6
                self.iMayaID = 8
                self.iAztecID = 9
                self.iNativeID = 11
                self.iNumPlayers = 12

                # Tech inits
                iOptics = 56
                iGalleons = 80
                iSignalling = 100
                iSextant = 113

                # initialise unit IDs
                self.iCaravelID = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_CARAVEL')
                self.iPikemanID = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_PIKEMAN')
                self.iSettlerID = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_SETTLER')
                self.iTraderCaravelID = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_TRADER_CARAVEL')
                self.iTraderGalleonID = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_TRADER_GALLEON')
                self.iTraderIndiamanID = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_TRADER_INDIAMAN')
                self.iPirateCaravelID = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_PIRATE_CARAVEL')
                self.iPirateGalleonID = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_PIRATE_GALLEON')
                self.iPirateFrigateID = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_PIRATE_FRIGATE')

		# Setup players for use in this function
		pEngland = gc.getPlayer(self.iEnglandID)
		pFrance = gc.getPlayer(self.iFranceID)
		pSpain = gc.getPlayer(self.iSpainID)
		pPortugal = gc.getPlayer(self.iPortugalID)
		pHolland = gc.getPlayer(self.iHollandID)
		pScotland = gc.getPlayer(self.iScotlandID)
		pSaxony = gc.getPlayer(self.iSaxonyID)
		pGenoa = gc.getPlayer(self.iGenoaID)
		pArab = gc.getPlayer(self.iArabID)
		
		# Colonizer helper every 20 turns on average
                if iTurn > 1 and iTurn < 150:
                    iRndNum = gc.getGame().getSorenRandNum(100, 'AoD - Random Event Start')
                    if iRndNum < 5:			# 5% chance
                        if (not pEngland.isHuman() and pEngland.isAlive()):
                            pEngland.initUnit(self.iCaravelID, 92, 51, UnitAITypes.UNITAI_SETTLER_SEA)
                            pEngland.initUnit(self.iPikemanID, 92, 51, UnitAITypes.UNITAI_COUNTER)
                            pEngland.initUnit(self.iSettlerID, 92, 51, UnitAITypes.UNITAI_SETTLE)
                    iRndNum = gc.getGame().getSorenRandNum(100, 'AoD - Random Event Start')
                    if iRndNum < 5:			# 5% chance
                        if (not pFrance.isHuman() and pFrance.isAlive()):
                            pFrance.initUnit(self.iCaravelID, 88, 47, UnitAITypes.UNITAI_SETTLER_SEA)
                            pFrance.initUnit(self.iPikemanID, 88, 47, UnitAITypes.UNITAI_COUNTER)
                            pFrance.initUnit(self.iSettlerID, 88, 47, UnitAITypes.UNITAI_SETTLE)
                    iRndNum = gc.getGame().getSorenRandNum(100, 'AoD - Random Event Start')
                    if iRndNum < 5:			# 5% chance
                        if (not pSpain.isHuman() and pSpain.isAlive()):
                            pSpain.initUnit(self.iCaravelID, 77, 26, UnitAITypes.UNITAI_SETTLER_SEA)
                            pSpain.initUnit(self.iPikemanID, 77, 26, UnitAITypes.UNITAI_COUNTER)
                            pSpain.initUnit(self.iSettlerID, 77, 26, UnitAITypes.UNITAI_SETTLE)
                    iRndNum = gc.getGame().getSorenRandNum(100, 'AoD - Random Event Start')
                    if iRndNum < 5:			# 5% chance
                        if (not pPortugal.isHuman() and pPortugal.isAlive()):
                            pPortugal.initUnit(self.iCaravelID, 75, 31, UnitAITypes.UNITAI_SETTLER_SEA)
                            pPortugal.initUnit(self.iPikemanID, 75, 31, UnitAITypes.UNITAI_COUNTER)
                            pPortugal.initUnit(self.iSettlerID, 75, 31, UnitAITypes.UNITAI_SETTLE)
                    iRndNum = gc.getGame().getSorenRandNum(100, 'AoD - Random Event Start')
                    if iRndNum < 5:			# 5% chance
                        if (not pHolland.isHuman() and pHolland.isAlive()):
                            pHolland.initUnit(self.iCaravelID, 103, 54, UnitAITypes.UNITAI_SETTLER_SEA)
                            pHolland.initUnit(self.iPikemanID, 103, 54, UnitAITypes.UNITAI_COUNTER)
                            pHolland.initUnit(self.iSettlerID, 103, 54, UnitAITypes.UNITAI_SETTLE)

		# Pirate helper every 20 turns on average
                if iTurn > 15:
                    iRndNum = gc.getGame().getSorenRandNum(100, 'AoD - Random Event')
                    if iRndNum < 5:
                        if(not pEngland.isHuman() and pEngland.isAlive()):
                            pCity = pEngland.getCoastalAWCity()
                            if(pCity.isValid()):
                                if (gc.getTeam(pEngland.getTeam()).isHasTech(iSignalling)):
                                    pEngland.initUnit(self.iPirateFrigateID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_EXPLORE_SEA)
                                elif (gc.getTeam(pEngland.getTeam()).isHasTech(iGalleons)):
                                    pEngland.initUnit(self.iPirateGalleonID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_EXPLORE_SEA)
                                elif (gc.getTeam(pEngland.getTeam()).isHasTech(iOptics)):
                                    pEngland.initUnit(self.iPirateCaravelID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_EXPLORE_SEA)
                    iRndNum = gc.getGame().getSorenRandNum(100, 'AoD - Random Event')
                    if iRndNum < 5:
                        if(not pFrance.isHuman() and pFrance.isAlive()):
                            pCity = pFrance.getCoastalAWCity()
                            if(pCity.isValid()):
                                if (gc.getTeam(pFrance.getTeam()).isHasTech(iSignalling)):
                                    pFrance.initUnit(self.iPirateFrigateID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_EXPLORE_SEA)
                                elif (gc.getTeam(pFrance.getTeam()).isHasTech(iGalleons)):
                                    pFrance.initUnit(self.iPirateGalleonID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_EXPLORE_SEA)
                                elif (gc.getTeam(pFrance.getTeam()).isHasTech(iOptics)):
                                    pFrance.initUnit(self.iPirateCaravelID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_EXPLORE_SEA)
                    iRndNum = gc.getGame().getSorenRandNum(100, 'AoD - Random Event')
                    if iRndNum < 5:
                        if(not pSpain.isHuman() and pSpain.isAlive()):
                            pCity = pSpain.getCoastalAWCity()
                            if(pCity.isValid()):
                                if (gc.getTeam(pSpain.getTeam()).isHasTech(iSignalling)):
                                    pSpain.initUnit(self.iPirateFrigateID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_EXPLORE_SEA)
                                elif (gc.getTeam(pSpain.getTeam()).isHasTech(iGalleons)):
                                    pSpain.initUnit(self.iPirateGalleonID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_EXPLORE_SEA)
                                elif (gc.getTeam(pSpain.getTeam()).isHasTech(iOptics)):
                                    pSpain.initUnit(self.iPirateCaravelID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_EXPLORE_SEA)
                    iRndNum = gc.getGame().getSorenRandNum(100, 'AoD - Random Event')
                    if iRndNum < 5:
                        if(not pPortugal.isHuman() and pPortugal.isAlive()):
                            pCity = pPortugal.getCoastalAWCity()
                            if(pCity.isValid()):
                                if (gc.getTeam(pPortugal.getTeam()).isHasTech(iSignalling)):
                                    pPortugal.initUnit(self.iPirateFrigateID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_EXPLORE_SEA)
                                elif (gc.getTeam(pPortugal.getTeam()).isHasTech(iGalleons)):
                                    pPortugal.initUnit(self.iPirateGalleonID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_EXPLORE_SEA)
                                elif (gc.getTeam(pPortugal.getTeam()).isHasTech(iOptics)):
                                    pPortugal.initUnit(self.iPirateCaravelID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_EXPLORE_SEA)
                    iRndNum = gc.getGame().getSorenRandNum(100, 'AoD - Random Event')
                    if iRndNum < 5:
                        if(not pHolland.isHuman() and pHolland.isAlive()):
                            pCity = pHolland.getCoastalAWCity()
                            if(pCity.isValid()):
                                if (gc.getTeam(pHolland.getTeam()).isHasTech(iSignalling)):
                                    pHolland.initUnit(self.iPirateFrigateID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_EXPLORE_SEA)
                                elif (gc.getTeam(pHolland.getTeam()).isHasTech(iGalleons)):
                                    pHolland.initUnit(self.iPirateGalleonID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_EXPLORE_SEA)
                                elif (gc.getTeam(pHolland.getTeam()).isHasTech(iOptics)):
                                    pHolland.initUnit(self.iPirateCaravelID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_EXPLORE_SEA)
                    iRndNum = gc.getGame().getSorenRandNum(100, 'AoD - Random Event')
                    if iRndNum < 5:
                        if(not pScotland.isHuman() and pScotland.isAlive()):
                            pCity = pScotland.getCoastalAWCity()
                            if(pCity.isValid()):
                                if (gc.getTeam(pScotland.getTeam()).isHasTech(iSignalling)):
                                    pScotland.initUnit(self.iPirateFrigateID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_EXPLORE_SEA)
                                elif (gc.getTeam(pScotland.getTeam()).isHasTech(iGalleons)):
                                    pScotland.initUnit(self.iPirateGalleonID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_EXPLORE_SEA)
                                elif (gc.getTeam(pScotland.getTeam()).isHasTech(iOptics)):
                                    pScotland.initUnit(self.iPirateCaravelID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_EXPLORE_SEA)
                    iRndNum = gc.getGame().getSorenRandNum(100, 'AoD - Random Event')
                    if iRndNum < 5:
                        if(not pSaxony.isHuman() and pSaxony.isAlive()):
                            pCity = pSaxony.getCoastalAWCity()
                            if(pCity.isValid()):
                                if (gc.getTeam(pSaxony.getTeam()).isHasTech(iSignalling)):
                                    pSaxony.initUnit(self.iPirateFrigateID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_EXPLORE_SEA)
                                elif (gc.getTeam(pSaxony.getTeam()).isHasTech(iGalleons)):
                                    pSaxony.initUnit(self.iPirateGalleonID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_EXPLORE_SEA)
                                elif (gc.getTeam(pSaxony.getTeam()).isHasTech(iOptics)):
                                    pSaxony.initUnit(self.iPirateCaravelID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_EXPLORE_SEA)
                    iRndNum = gc.getGame().getSorenRandNum(100, 'AoD - Random Event')
                    if iRndNum < 5:
                        if(not pGenoa.isHuman() and pGenoa.isAlive()):
                            pCity = pGenoa.getCoastalAWCity()
                            if(pCity.isValid()):
                                if (gc.getTeam(pGenoa.getTeam()).isHasTech(iSignalling)):
                                    pGenoa.initUnit(self.iPirateFrigateID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_EXPLORE_SEA)
                                elif (gc.getTeam(pGenoa.getTeam()).isHasTech(iGalleons)):
                                    pGenoa.initUnit(self.iPirateGalleonID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_EXPLORE_SEA)
                                elif (gc.getTeam(pGenoa.getTeam()).isHasTech(iOptics)):
                                    pGenoa.initUnit(self.iPirateCaravelID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_EXPLORE_SEA)
                    iRndNum = gc.getGame().getSorenRandNum(100, 'AoD - Random Event')
                    if iRndNum < 5:
                        if(not pArab.isHuman() and pArab.isAlive()):
                            pCity = pArab.getCoastalAWCity()
                            if(pCity.isValid()):
                                if (gc.getTeam(pArab.getTeam()).isHasTech(iSignalling)):
                                    pArab.initUnit(self.iPirateFrigateID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_EXPLORE_SEA)
                                elif (gc.getTeam(pArab.getTeam()).isHasTech(iGalleons)):
                                    pArab.initUnit(self.iPirateGalleonID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_EXPLORE_SEA)
                                elif (gc.getTeam(pArab.getTeam()).isHasTech(iOptics)):
                                    pArab.initUnit(self.iPirateCaravelID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_EXPLORE_SEA)
                            
		# Trader generator every 5 turns on average
                if iTurn > 0:
                    pCity = pEngland.getCapitalCity()
                    iRndNum = gc.getGame().getSorenRandNum(100, 'AoD - Random Event')
                    if iRndNum < 20:
                        if(pEngland.isAlive()):
                            pTempCity = pEngland.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            pTempCity = pEngland.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            pTempCity = pEngland.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            pTempCity = pEngland.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            pTempCity = pEngland.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            if(pCity.getX() < 70):
                                if (gc.getTeam(pEngland.getTeam()).isHasTech(iSextant)):
                                    pEngland.initUnit(self.iTraderIndiamanID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_ATTACK_SEA)
                                elif (gc.getTeam(pEngland.getTeam()).isHasTech(iGalleons)):
                                    pEngland.initUnit(self.iTraderGalleonID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_ATTACK_SEA)
                                elif (gc.getTeam(pEngland.getTeam()).isHasTech(iOptics)):
                                    pEngland.initUnit(self.iTraderCaravelID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_ATTACK_SEA)
                    pCity = pFrance.getCapitalCity()
                    iRndNum = gc.getGame().getSorenRandNum(100, 'AoD - Random Event')
                    if iRndNum < 20:
                        if(pFrance.isAlive()):
                            pTempCity = pFrance.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            pTempCity = pFrance.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            pTempCity = pFrance.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            pTempCity = pFrance.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            pTempCity = pFrance.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            if(pCity.getX() < 70):
                                if (gc.getTeam(pFrance.getTeam()).isHasTech(iSextant)):
                                    pFrance.initUnit(self.iTraderIndiamanID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_ATTACK_SEA)
                                elif (gc.getTeam(pFrance.getTeam()).isHasTech(iGalleons)):
                                    pFrance.initUnit(self.iTraderGalleonID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_ATTACK_SEA)
                                elif (gc.getTeam(pFrance.getTeam()).isHasTech(iOptics)):
                                    pFrance.initUnit(self.iTraderCaravelID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_ATTACK_SEA)
                    pCity = pSpain.getCapitalCity()
                    iRndNum = gc.getGame().getSorenRandNum(100, 'AoD - Random Event')
                    if iRndNum < 20:
                        if(pSpain.isAlive()):
                            pTempCity = pSpain.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            pTempCity = pSpain.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            pTempCity = pSpain.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            pTempCity = pSpain.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            pTempCity = pSpain.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            if(pCity.getX() < 70):
                                if (gc.getTeam(pSpain.getTeam()).isHasTech(iSextant)):
                                    pSpain.initUnit(self.iTraderIndiamanID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_ATTACK_SEA)
                                elif (gc.getTeam(pSpain.getTeam()).isHasTech(iGalleons)):
                                    pSpain.initUnit(self.iTraderGalleonID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_ATTACK_SEA)
                                elif (gc.getTeam(pSpain.getTeam()).isHasTech(iOptics)):
                                    pSpain.initUnit(self.iTraderCaravelID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_ATTACK_SEA)
                    pCity = pPortugal.getCapitalCity()
                    iRndNum = gc.getGame().getSorenRandNum(100, 'AoD - Random Event')
                    if iRndNum < 20:
                        if(pPortugal.isAlive()):
                            pTempCity = pPortugal.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            pTempCity = pPortugal.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            pTempCity = pPortugal.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            pTempCity = pPortugal.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            pTempCity = pPortugal.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            if(pCity.getX() < 70):
                                if (gc.getTeam(pPortugal.getTeam()).isHasTech(iSextant)):
                                    pPortugal.initUnit(self.iTraderIndiamanID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_ATTACK_SEA)
                                elif (gc.getTeam(pPortugal.getTeam()).isHasTech(iGalleons)):
                                    pPortugal.initUnit(self.iTraderGalleonID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_ATTACK_SEA)
                                elif (gc.getTeam(pPortugal.getTeam()).isHasTech(iOptics)):
                                    pPortugal.initUnit(self.iTraderCaravelID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_ATTACK_SEA)
                    pCity = pHolland.getCapitalCity()
                    iRndNum = gc.getGame().getSorenRandNum(100, 'AoD - Random Event')
                    if iRndNum < 20:
                        if(pHolland.isAlive()):
                            pTempCity = pHolland.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            pTempCity = pHolland.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            pTempCity = pHolland.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            pTempCity = pHolland.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            pTempCity = pHolland.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            if(pCity.getX() < 70):
                                if (gc.getTeam(pHolland.getTeam()).isHasTech(iSextant)):
                                    pHolland.initUnit(self.iTraderIndiamanID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_ATTACK_SEA)
                                elif (gc.getTeam(pHolland.getTeam()).isHasTech(iGalleons)):
                                    pHolland.initUnit(self.iTraderGalleonID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_ATTACK_SEA)
                                elif (gc.getTeam(pHolland.getTeam()).isHasTech(iOptics)):
                                    pHolland.initUnit(self.iTraderCaravelID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_ATTACK_SEA)
                    pCity = pScotland.getCapitalCity()
                    iRndNum = gc.getGame().getSorenRandNum(100, 'AoD - Random Event')
                    if iRndNum < 20:
                        if(pScotland.isAlive()):
                            pTempCity = pScotland.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            pTempCity = pScotland.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            pTempCity = pScotland.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            pTempCity = pScotland.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            pTempCity = pScotland.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            if(pCity.getX() < 70):
                                if (gc.getTeam(pScotland.getTeam()).isHasTech(iSextant)):
                                    pScotland.initUnit(self.iTraderIndiamanID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_ATTACK_SEA)
                                elif (gc.getTeam(pScotland.getTeam()).isHasTech(iGalleons)):
                                    pScotland.initUnit(self.iTraderGalleonID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_ATTACK_SEA)
                                elif (gc.getTeam(pScotland.getTeam()).isHasTech(iOptics)):
                                    pScotland.initUnit(self.iTraderCaravelID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_ATTACK_SEA)
                    pCity = pSaxony.getCapitalCity()
                    iRndNum = gc.getGame().getSorenRandNum(100, 'AoD - Random Event')
                    if iRndNum < 20:
                        if(pSaxony.isAlive()):
                            pTempCity = pSaxony.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            pTempCity = pSaxony.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            pTempCity = pSaxony.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            pTempCity = pSaxony.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            pTempCity = pSaxony.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            if(pCity.getX() < 70):
                                if (gc.getTeam(pSaxony.getTeam()).isHasTech(iSextant)):
                                    pSaxony.initUnit(self.iTraderIndiamanID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_ATTACK_SEA)
                                elif (gc.getTeam(pSaxony.getTeam()).isHasTech(iGalleons)):
                                    pSaxony.initUnit(self.iTraderGalleonID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_ATTACK_SEA)
                                elif (gc.getTeam(pSaxony.getTeam()).isHasTech(iOptics)):
                                    pSaxony.initUnit(self.iTraderCaravelID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_ATTACK_SEA)
                    pCity = pGenoa.getCapitalCity()
                    iRndNum = gc.getGame().getSorenRandNum(100, 'AoD - Random Event')
                    if iRndNum < 20:
                        if(pGenoa.isAlive()):
                            pTempCity = pGenoa.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            pTempCity = pGenoa.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            pTempCity = pGenoa.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            pTempCity = pGenoa.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            pTempCity = pGenoa.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            if(pCity.getX() < 70):
                                if (gc.getTeam(pGenoa.getTeam()).isHasTech(iSextant)):
                                    pGenoa.initUnit(self.iTraderIndiamanID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_ATTACK_SEA)
                                elif (gc.getTeam(pGenoa.getTeam()).isHasTech(iGalleons)):
                                    pGenoa.initUnit(self.iTraderGalleonID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_ATTACK_SEA)
                                elif (gc.getTeam(pGenoa.getTeam()).isHasTech(iOptics)):
                                    pGenoa.initUnit(self.iTraderCaravelID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_ATTACK_SEA)
                    pCity = pArab.getCapitalCity()
                    iRndNum = gc.getGame().getSorenRandNum(100, 'AoD - Random Event')
                    if iRndNum < 20:
                        if(pArab.isAlive()):
                            pTempCity = pArab.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            pTempCity = pArab.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            pTempCity = pArab.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            pTempCity = pArab.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            pTempCity = pArab.getCoastalNWCity()
                            if(pTempCity.getX() < 70):
                                pCity = pTempCity
                            if(pCity.getX() < 70):
                                if (gc.getTeam(pArab.getTeam()).isHasTech(iSextant)):
                                    pArab.initUnit(self.iTraderIndiamanID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_ATTACK_SEA)
                                elif (gc.getTeam(pArab.getTeam()).isHasTech(iGalleons)):
                                    pArab.initUnit(self.iTraderGalleonID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_ATTACK_SEA)
                                elif (gc.getTeam(pArab.getTeam()).isHasTech(iOptics)):
                                    pArab.initUnit(self.iTraderCaravelID, pCity.getX(), pCity.getY(), UnitAITypes.UNITAI_ATTACK_SEA)

		# Insert all game turn events here
#		print("Turn is: %d" %(iTurn))
#		if (iTurn == 4 + self.iTurnOffset):
#			self.Nov_1775()
#		elif (iTurn == 6 + self.iTurnOffset):
#			self.Jan_1776()

# AoD Utilities
###################################################
                
